/* 
   Copyright (c) 2001 Paul Campbell - paul@taniwha.com
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
                           
#ifndef __CRESOURCES_h
#define __CRESOURCES_h 1
extern "C" {
#include "resources.h"
}

class res_fd;
class res_file;
class res_dir;

class res_env 
{
public:
	res_env(const char *name=0);
	~res_env();
	int stat(const char *file_name, struct stat *buf); 
	res_fd *open(const char *name);
	res_file *fopen(const char *name);
	res_dir *opendir(const char *name);
private:
	struct RES_ENV	*rf;
};

class res_fd
{
public:
	res_fd(struct RES_FD *fd);
	~res_fd();

	int read(void *buf, size_t count);   
	int fstat(struct stat *buf);  
	int lseek(off_t offset, int whence);     
private:
	struct RES_FD	*fd;
};

class res_file
{
public:
	res_file(struct RES_FILE *f);
	~res_file();
	int fread(void *ptr, size_t size, size_t nmemb);
	void clearerr();
	int feof();
	int ferror();
	int fgetc();
	int ungetc(int c);
	char *fgets(char *s, int size);
	int fseek( long offset, int whence);
	int ftell();
	int rewind();
	int fgetpos(fpos_t *pos);  
	int fsetpos(fpos_t *pos);  
private:
	struct RES_FILE *f;
};

class res_dir
{
public:
	res_dir(struct RES_DIR *f);
	~res_dir();
	struct dirent *readdir();
	off_t telldir();
	void seekdir(off_t offset);
	void rewinddir();
private:
	struct RES_DIR *dp;
};
#endif
