/* 
   Copyright (c) 2001 Paul Campbell - paul@taniwha.com
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
                           
#include <sys/stat.h>
#include <unistd.h>   
#include <stdlib.h>   
#include <string.h>   
#include <dirent.h>   
#include "cresources.h"

res_env *res;

void
dump_dir(int ind, char *name, int recurse) 
{
	int i;
	struct dirent *d;
	struct stat s;
	char *cp;
	res_dir *dp=NULL;
	res_file *f=NULL;
	int l;
	char data[256];

	if (res->stat(name, &s)) {
		fprintf(stderr, "stat on '%s' failed\n", name);
		exit(1);
	}	
	if (S_ISREG(s.st_mode)) {
		for (i = 0; i < ind; i++)
			printf("  ");
		printf("%s file size=%d\n", name, s.st_size);
		f = res->fopen(name);
		if (f == NULL) {
			fprintf(stderr, "fopen on '%s' failed\n", name);
			exit(1);
		}
		printf("DATA-------------\n");
		for (;;) {
			l = f->fread(data, 1, sizeof(data));
			if (l < 0) {
				fprintf(stderr, "fread on '%s' failed\n", name);
				exit(1);
			}
			if (l == 0)
				break;
			fwrite(data, 1, l, stdout);
		}
		printf("EDATA------------\n");
		delete f;
		return;
	} else
	if (!S_ISDIR(s.st_mode)) {
		fprintf(stderr, "bad type on file '%s'\n", name);
		exit(1);
	}
	for (i = 0; i < ind; i++)
		printf("  ");
	printf("%s dir\n", name);
	if (!recurse)
		return;
	dp = res->opendir(name);
	if (dp == NULL) {
		fprintf(stderr, "bad disr search on dir '%s'\n", name);
		exit(1);
	}
	for (;;) {
		d = dp->readdir();
		if (d == NULL)
			break;
		cp = (char *)::malloc(strlen(name)+1+strlen(&d->d_name[0])+1);
		::strcpy(cp, name);
		::strcat(cp, "/");
		::strcat(cp, &d->d_name[0]);
		if (::strcmp(&d->d_name[0], ".") == 0 ||
	    	    ::strcmp(&d->d_name[0], "..") == 0) {
			dump_dir(ind+1, cp, 0);
		} else {
			dump_dir(ind+1, cp, 1);
		}
		::free(cp);
	}
	delete dp;
}



main()
{
	res = new res_env(NULL);
	dump_dir(0, ".", 1);
	delete res;
	exit(0);
}
